Name:           libflatarray
Version:        0.1.1
Release:        1%{?dist}
Summary:        C++ library for highly efficient multi-dimensional arrays
License:        Boost
URL:            http://www.libgeodecomp.org/libflatarray.html
Source0:        http://www.libgeodecomp.org/archive/libflatarray-%{version}.tar.bz2
BuildRequires:  boost-devel
BuildRequires:  cmake

%description
LibFlatArray acts as a highly efficient multi-dimensional array of
arbitrary objects (array of structs, AoS), but really uses a struct of
arrays (SoA) memory layout. It's great for writing vectorized code and
its lightning-fast iterators give you access to neighboring elements
with zero address generation overhead.

Use cases include:
- computer simulations (e.g. stencil codes such as Lattice Boltzmann Methods)
- image processing (e.g. Gaussian filters)
- numerical methods (e.g. multiplication of complex matrices)

The library is written in C++ and uses templates to shift the burden
of address computation from runtime to compile time. It shares some
infrastructure with its parent project LibGeoDecomp.

%package        devel
Summary:        Development files for %{name}
#Requires:       %{name}%{?_isa} = %{version}-%{release}
Provides:       %{name}-static = %{version}-%{release}

%description    devel
#This package contains libraries and header files for
This package contains header files for
developing applications that use %{name}.

%prep
%setup -q

%build
%cmake -DWITH_CUDA=OFF .
make %{?_smp_mflags}

%install
make install DESTDIR=%{buildroot}

%files devel
%doc AUTHORS LICENSE README
%doc examples/
%dir %{_includedir}/libflatarray
%{_includedir}/libflatarray/aligned_allocator.hpp
%{_includedir}/libflatarray/cuda_allocator.hpp
%{_includedir}/libflatarray/flat_array.hpp

%changelog
* Sun Jan 26 2014 Christopher Meng <rpm@cicku.me> - 0.1.1-1
- Initial Package.
